-- name: [CS] Fazbear 64
-- description: Play as everyone's favorite haunted animatronics in Super Mario 64!

if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local SOUND_KIDSCHEER = audio_sample_load('cheer.ogg')

local TEX_PIZZA_ICON = get_texture_info("pizza-icon")
local E_MODEL_PIZZASLICE = smlua_model_util_get_id("pizzaslice_geo")

local E_MODEL_FREDDY = smlua_model_util_get_id("freddy_geo")
local E_MODEL_GFREDDY = smlua_model_util_get_id("gfreddy_geo")
local E_MODEL_BONNIE = smlua_model_util_get_id("bonnie_geo")
local E_MODEL_MBONNIE = smlua_model_util_get_id("mbonnie_geo")
local E_MODEL_CHICA = smlua_model_util_get_id("chica_geo")

local TEX_LIVES_ICON = get_texture_info("fnaflives")

local TEXT_MOD_NAME = "Fazbear 64"

local HEALTH_METER_FNAF= {
    label = {
        left = get_texture_info("fazbearhealthleft"),
        right = get_texture_info("fazbearhealthright"),
    },
    pie = {
        [1] = get_texture_info("fnafpie-1"),
        [2] = get_texture_info("fnafpie-2"),
        [3] = get_texture_info("fnafpie-3"),
        [4] = get_texture_info("fnafpie-4"),
        [5] = get_texture_info("fnafpie-5"),
        [6] = get_texture_info("fnafpie-6"),
        [7] = get_texture_info("fnafpie-7"),
        [8] = get_texture_info("fnafpie-8"),
    }
}

local PALETTE_FREDDY = {
    [PANTS]  = "5E2D01", -- nil
    [SHIRT]  = "1A1A1A", -- accents
    [GLOVES] = "5E2D01", -- hands
    [SHOES]  = "5E2D01", -- feet
    [HAIR]   = "5E2D01", -- main
    [SKIN]   = "764302", -- belly
    [CAP]    = "1A1A1A", -- hat
}

local PALETTE_GFREDDY = {
    [PANTS]  = "B18711", -- nil
    [SHIRT]  = "000000", -- accents
    [GLOVES] = "B18711", -- hands
    [SHOES]  = "B18711", -- feet
    [HAIR]   = "B18711", -- main
    [SKIN]   = "D4A118", -- belly
    [CAP]    = "000000", -- hat
}

local PALETTE_BONNIE = {
    [PANTS]  = "443468", -- nil
    [SHIRT]  = "1A1A1A", -- accents
    [GLOVES] = "443468", -- hands
    [SHOES]  = "443468", -- feet
    [HAIR]   = "443468", -- main
    [SKIN]   = "625C71", -- belly
    [CAP]    = "6E0000", -- hat
}

local PALETTE_MBONNIE = {
    [PANTS]  = "224968", -- nil
    [SHIRT]  = "1A1A1A", -- accents
    [GLOVES] = "224968", -- hands
    [SHOES]  = "224968", -- feet
    [HAIR]   = "224968", -- main
    [SKIN]   = "93ABAB", -- belly
    [CAP]    = "7A1A1B", -- hat
}

local PALETTE_CHICA = {
    [PANTS]  = "937F15", -- nil
    [SHIRT]  = "937F15", -- main
    [GLOVES] = "937F15", -- hands
    [SHOES]  = "9B4709", -- feet
    [HAIR]   = "1A1A1A", -- accents
    [SKIN]   = "AFA139", -- belly
    [CAP]    = "D9517F", -- hat
}

local CAPS_FREDDY = {
    normal = smlua_model_util_get_id("freddycap_geo"),
    wing = smlua_model_util_get_id("freddywingcap_geo"),
    metal = smlua_model_util_get_id("freddymetalcap_geo"),
    metalWing = smlua_model_util_get_id("freddywingmetalcap_geo"),
}

local CAPS_BONNIE = {
    normal = smlua_model_util_get_id("bonniecap_geo"),
    wing = smlua_model_util_get_id("bonniewingcap_geo"),
    metal = smlua_model_util_get_id("bonniemetalcap_geo"),
    metalWing = smlua_model_util_get_id("bonniewingmetalcap_geo"),
}

local CAPS_CHICA = {
    normal = smlua_model_util_get_id("cupcake_geo"),
    wing = smlua_model_util_get_id("wingedcupcake_geo"),
    metal = smlua_model_util_get_id("metalcupcake_geo"),
    metalWing = smlua_model_util_get_id("metalwingedcupcake_geo"),
}

local VOICETABLE_FREDDY = {
    [CHAR_SOUND_ATTACKED] = {'clank1.ogg','clank2.ogg','clank3.ogg'},
    [CHAR_SOUND_DOH] = {'clank1.ogg','clank2.ogg','clank3.ogg'},
    [CHAR_SOUND_DROWNING] = 'powerdown.ogg',
    [CHAR_SOUND_DYING] = 'powerdown.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'freddyhah.ogg',
    [CHAR_SOUND_HAHA] = {'freddyhaha.ogg','freddywahoo.ogg'},
    [CHAR_SOUND_HAHA_2] = 'freddyhaha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = {'freddylaughshort.ogg','freddywahoo.ogg'},
    [CHAR_SOUND_HOOHOO] = 'metalrun.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'freddyaww.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'freddylaughshort.ogg',
    [CHAR_SOUND_ON_FIRE] = 'XSCREAM.ogg',
    [CHAR_SOUND_OOOF] = 'freddyaww.ogg',
    [CHAR_SOUND_OOOF2] = 'freddyaww.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'clank1.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'clank2.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'metalrun.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'freddylaughshort.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = {'freddywahoo.ogg','metaljump2.ogg'},
    [CHAR_SOUND_WAAAOOOW] = 'XSCREAM.ogg',
    [CHAR_SOUND_WAH2] = 'freddyyah.ogg',
    [CHAR_SOUND_WHOA] = 'freddyhah.ogg',
    [CHAR_SOUND_YAHOO] = {'freddywahoo.ogg','metaljump2.ogg'},
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'clank2.ogg','freddyyah.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'freddyyah.ogg','metalrun.ogg','freddyhah.ogg','clank2.ogg'},
    [CHAR_SOUND_YAWNING] = {'moan1.ogg','moan2.ogg','moan3.ogg','moan4.ogg'},
}

local VOICETABLE_MUTE = {
    [CHAR_SOUND_ATTACKED] = {'clank1.ogg','clank2.ogg','clank3.ogg'},
    [CHAR_SOUND_DOH] = {'clank1.ogg','clank2.ogg','clank3.ogg'},
    [CHAR_SOUND_DROWNING] = 'powerdown.ogg',
    [CHAR_SOUND_DYING] = 'powerdown.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'clank3.ogg',
    [CHAR_SOUND_HAHA] = nil,
    [CHAR_SOUND_HAHA_2] = nil,
    [CHAR_SOUND_HERE_WE_GO] = nil,
    [CHAR_SOUND_HOOHOO] = 'metalrun.ogg',
    [CHAR_SOUND_MAMA_MIA] = nil,
    [CHAR_SOUND_OKEY_DOKEY] = nil,
    [CHAR_SOUND_ON_FIRE] = 'XSCREAM.ogg',
    [CHAR_SOUND_OOOF] = 'clank3.ogg',
    [CHAR_SOUND_OOOF2] = 'clank3.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'clank1.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'clank2.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'metalrun.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = nil,
    [CHAR_SOUND_TWIRL_BOUNCE] = 'metaljump2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'XSCREAM.ogg',
    [CHAR_SOUND_WAH2] = nil,
    [CHAR_SOUND_WHOA] = nil,
    [CHAR_SOUND_YAHOO] = 'metaljump2.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'clank2.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = {'metalrun.ogg','clank2.ogg'},
    [CHAR_SOUND_YAWNING] = {'moan1.ogg','moan2.ogg','moan3.ogg','moan4.ogg'},
}

local CSloaded = false
local function on_character_select_load()
    _G.CT_FREDDY = _G.charSelect.character_add("Freddy Fazbear", "The one and only. Singer in the animatronic band.", "SwagSkeleton95", {r = 94, g = 45, b = 1}, E_MODEL_FREDDY, CT_MARIO, TEX_LIVES_ICON, 1.0, 6)
    _G.CT_BONNIE = _G.charSelect.character_add("Bonnie the Bunny", "The guitarist of the animatronic band.", "SwagSkeleton95", {r = 68, g = 52, b = 104}, E_MODEL_BONNIE, CT_LUIGI, TEX_LIVES_ICON, 1.0, 6)
    _G.CT_CHICA = _G.charSelect.character_add("Chica the Chicken", "Chica's here to encourage you to eat! Also a singer in the band?", "SwagSkeleton95", {r = 147, g = 127, b = 21}, E_MODEL_CHICA, CT_WARIO, TEX_LIVES_ICON, 1.0, 6)

    _G.charSelect.character_add_voice(E_MODEL_FREDDY, VOICETABLE_FREDDY)
    _G.charSelect.character_add_voice(E_MODEL_GFREDDY, VOICETABLE_FREDDY)
    _G.charSelect.character_add_voice(E_MODEL_BONNIE, VOICETABLE_MUTE)
    _G.charSelect.character_add_voice(E_MODEL_MBONNIE, VOICETABLE_MUTE)
    _G.charSelect.character_add_voice(E_MODEL_CHICA, VOICETABLE_MUTE)

    _G.charSelect.character_add_caps(E_MODEL_FREDDY, CAPS_FREDDY)
    _G.charSelect.character_add_caps(E_MODEL_GFREDDY, CAPS_FREDDY)
    _G.charSelect.character_add_caps(E_MODEL_BONNIE, CAPS_BONNIE)
    _G.charSelect.character_add_caps(E_MODEL_MBONNIE, CAPS_BONNIE)
    _G.charSelect.character_add_caps(E_MODEL_CHICA, CAPS_CHICA)

    _G.charSelect.character_add_palette_preset(E_MODEL_FREDDY, PALETTE_FREDDY)
    _G.charSelect.character_add_palette_preset(E_MODEL_GFREDDY, PALETTE_GFREDDY)
    _G.charSelect.character_add_palette_preset(E_MODEL_BONNIE, PALETTE_BONNIE)
    _G.charSelect.character_add_palette_preset(E_MODEL_MBONNIE, PALETTE_MBONNIE)
    _G.charSelect.character_add_palette_preset(E_MODEL_CHICA, PALETTE_CHICA)

    _G.charSelect.character_add_celebration_star(E_MODEL_FREDDY, E_MODEL_PIZZASLICE, TEX_PIZZA_ICON)
    _G.charSelect.character_add_celebration_star(E_MODEL_GFREDDY, E_MODEL_PIZZASLICE, TEX_PIZZA_ICON)
    _G.charSelect.character_add_celebration_star(E_MODEL_BONNIE, E_MODEL_PIZZASLICE, TEX_PIZZA_ICON)
    _G.charSelect.character_add_celebration_star(E_MODEL_MBONNIE, E_MODEL_PIZZASLICE, TEX_PIZZA_ICON)
    _G.charSelect.character_add_celebration_star(E_MODEL_CHICA, E_MODEL_PIZZASLICE, TEX_PIZZA_ICON)

    _G.charSelect.character_add_health_meter(CT_FREDDY, HEALTH_METER_FNAF)
    _G.charSelect.character_add_health_meter(CT_BONNIE, HEALTH_METER_FNAF)
    _G.charSelect.character_add_health_meter(CT_CHICA, HEALTH_METER_FNAF)

    CSloaded = true
    CHARS_FNAF = {
    	[CT_FREDDY] = 1,
    	[CT_BONNIE] = 1,
    	[CT_CHICA] = 1,
    	-- [CT_FOXY] = 1,
    	-- [CT_SPRINGTRAP] = 1,
    }
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_FREDDY then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MUTE then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_FREDDY then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MUTE then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)

-- Play cheers





local function on_interact(m, o, intType)
    if not CSloaded then return end
    if m.playerIndex ~= 0 then return end
    if intType == INTERACT_STAR_OR_KEY and CHARS_FNAF[_G.charSelect.character_get_current_number()] then
        audio_sample_play(SOUND_KIDSCHEER, m.pos, 1.0)
    end
end

hook_event(HOOK_ON_INTERACT, on_interact)


--------------------------------------------
--- Alt Costume code from Paper Partners ---
------------ Thanks, Melzinoff!! -----------
--------- Original code by Wibblus!! -------
--------------------------------------------

local CUR_SKIN_FREDDY = 1
-- table of skins
local SKINTABLE_FREDDY = {
    { model = E_MODEL_FREDDY,  name = "Freddy Fazbear", desc = "The one and only. Singer in the animatronic band.", credit = "SwagSkeleton95", color = {r = 94, g = 45, b = 1}, E_MODEL_FREDDY, CT_MARIO, TEX_LIVES_ICON, offset = 6},
    { model = E_MODEL_GFREDDY,  name = "Golden Freddy", desc = "#######################", credit = "SwagSkeleton95", color = {r = 177, g = 135, b = 17}, E_MODEL_GFREDDY, CT_MARIO, TEX_LIVES_ICON, offset = 6},
}

local function update_character_skin()
    local curFreddySkin = SKINTABLE_FREDDY[CUR_SKIN_FREDDY]
    _G.charSelect.character_edit(CT_FREDDY, curFreddySkin.name, curFreddySkin.desc, curFreddySkin.credit, curFreddySkin.color, curFreddySkin.model, nil, curFreddySkin[6], nil, curFreddySkin.offset)
end
local inputLockTimer = 0
_G.charSelect.hook_render_in_menu(function()
    if _G.charSelect.character_get_current_number() == CT_FREDDY then
        ---@type Controller
        local c = _G.charSelect.controller

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local scale = 0.5
        local x1 = djui_hud_get_screen_width() * .048
        local x2 = x1 + math.max(85, djui_hud_get_screen_width() * .196)

        -- >
        if CUR_SKIN_FREDDY < #SKINTABLE_FREDDY then
            -- the < > icons move with inputLockTimer for very cool reactive ui
            djui_hud_print_text(">", x2 + inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                CUR_SKIN_FREDDY = CUR_SKIN_FREDDY + 1
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- <
        if CUR_SKIN_FREDDY > 1 then
            djui_hud_print_text("<", x1 - inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                CUR_SKIN_FREDDY = math.max(CUR_SKIN_FREDDY - 1, 1)
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- use an input lock to prevent cycling too fast
        inputLockTimer = math.max(0, inputLockTimer - 1)
    end
end)



local CUR_SKIN_BONNIE = 1
-- table of skins
local SKINTABLE_BONNIE = {
    { model = E_MODEL_BONNIE,  name = "Bonnie the Bunny", desc = "The guitarist of the animatronic band.", credit = "SwagSkeleton95", color = {r = 68, g = 52, b = 104}, E_MODEL_BONNIE, CT_LUIGI, TEX_LIVES_ICON, offset = 6},
    { model = E_MODEL_MBONNIE,  name = "Bonnie (Movie)", desc = "The guitarist of the animatronic band. This version is based on the movie.", credit = "SwagSkeleton95", color = {r = 34, g = 73, b = 104}, E_MODEL_MBONNIE, CT_LUIGI, TEX_LIVES_ICON, offset = 6},
}

local function update_character_skin()
    local curBonnieSkin = SKINTABLE_BONNIE[CUR_SKIN_BONNIE]
    _G.charSelect.character_edit(CT_BONNIE, curBonnieSkin.name, curBonnieSkin.desc, curBonnieSkin.credit, curBonnieSkin.color, curBonnieSkin.model, nil, curBonnieSkin[6], nil, curBonnieSkin.offset)
end
local inputLockTimer = 0
_G.charSelect.hook_render_in_menu(function()
    if _G.charSelect.character_get_current_number() == CT_BONNIE then
        ---@type Controller
        local c = _G.charSelect.controller

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local scale = 0.5
        local x1 = djui_hud_get_screen_width() * .048
        local x2 = x1 + math.max(85, djui_hud_get_screen_width() * .196)

        -- >
        if CUR_SKIN_BONNIE < #SKINTABLE_BONNIE then
            -- the < > icons move with inputLockTimer for very cool reactive ui
            djui_hud_print_text(">", x2 + inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                CUR_SKIN_BONNIE = CUR_SKIN_BONNIE + 1
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- <
        if CUR_SKIN_BONNIE > 1 then
            djui_hud_print_text("<", x1 - inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                CUR_SKIN_BONNIE = math.max(CUR_SKIN_BONNIE - 1, 1)
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- use an input lock to prevent cycling too fast
        inputLockTimer = math.max(0, inputLockTimer - 1)
    end
end)